#[derive(Clone, Debug, Default)]
pub struct BTree<K: Ord, V> {
    root: Option<Node<K, V>>,
    len: usize,
}

#[derive(Clone, Debug)]
pub struct Node<K, V> {
    key: K,
    value: V,
}

impl<K, V> Node<K, V> {
    pub fn new_root(key: K, value: V) -> Self {
        Node { key, value }
    }
}

impl<K: Ord, V> BTree<K, V> {
    pub fn new() -> Self {
        Self { root: None, len: 0 }
    }

    pub fn clear(&mut self) {
        self.root = None;
        self.len = 0;
    }

    pub fn rebalance() {
        todo!()
    }

    pub fn insert(&mut self, key: K, value: V) -> Option<V> {
        if let Some(root) = &self.root {
            todo!()
        } else {
            let new_node = Node::new_root(key, value);
            self.root = Some(new_node);
            None
        }
    }

    pub fn remove(&mut self, key: K) -> Option<V> {
        todo!()
    }

    pub fn has_key(&self, key: K) -> bool {
        todo!()
    }

    pub fn get(&self, key: K) -> Option<&V> {
        todo!()
    }

    pub fn get_mut(&mut self, key: K) -> Option<&mut V> {
        todo!()
    }

    pub fn get_node(&self, key: K) -> Option<&Node<K, V>> {
        todo!()
    }

    pub fn get_node_mut(&mut self, key: K) -> Option<&mut Node<K, V>> {
        todo!()
    }
}

#[cfg(test)]
mod test {
    use super::*;
    #[test]
    fn test_create() {
        let _tree = BTree::<u32, u32>::default();
    }

    #[test]
    fn test_insert() {
        let mut tree = BTree::<u32, &str>::default();
        tree.insert(19, "19");
        tree.insert(9, "09");
        tree.insert(14, "14");

        assert!(tree.get(19).is_some_and(|s| *s == "19"));
        assert!(tree.get(9).is_some_and(|s| *s == "09"));
        assert!(tree.get(14).is_some_and(|s| *s == "14"));
    }
}
